/* Generated By:JavaCC: Do not edit this line. NodeReaderJpel.java */
package jpel.bridge;

import java.io.*;
import java.util.*;

import jpel.language.*;
import jpel.tree.*;
import jpel.util.dataholder.*;

/**
 * Implementao do parser utilizando JavaCC.
 */
public class NodeReaderJpel implements NodeReader, ExpressionParser, NodeReaderJpelConstants {

    private NodeFactory factory;
    private EnvironmentFactory envFactory;
    private DataHolderFactory holderFactory;

    public NodeReaderJpel() throws ClassNotFoundException, IllegalAccessException, InstantiationException {
        this(new StringReader(""));
        factory = NodeBuilder.getNodeFactory();
        envFactory = EnvironmentBuilder.getEnvironmentFactory();
        holderFactory = DataHolderBuilder.getDataHolderFactory();
    }

    public String[] getTypes() {
        return new String[]{"jpel"};
    }

    public String getDescription() {
        return "JPEL Resources";
    }

    public Node read(DataHolder holder) throws NodeException, DataHolderException {
        try {
            InputStream in = holder.getInputStream();
            ReInit(in);
            Node node = getNode(new Include(holder,null));
            return node;
        }
        catch(ParseException exc) {
            throw new DataHolderException(exc.getMessage(),exc);
        }
        catch(DataHolderFactoryException exc) {
            throw new DataHolderException(exc.getMessage(),exc);
        }
    }

    public Expression getExpression(String dataExpression) throws ExpressionParserException {
        try {
            Reader reader = new StringReader(dataExpression);
            Expression exp = getExpression(reader);
            reader.close();
            exp.setSource(dataExpression);
            return exp;
        }
        catch(IOException exc) {
            throw new ExpressionParserException(exc.getMessage(),exc);
        }
    }

    public Expression getExpression(InputStream dataExpression) throws ExpressionParserException {
        Expression exp = getExpression(new InputStreamReader(dataExpression));
        exp.setSource(dataExpression);
        return exp;
    }

    public Expression getExpression(Reader dataExpression) throws ExpressionParserException {
        try {
            ReInit(dataExpression);
            Expression exp = getExpression();
            exp.setSource(dataExpression);
            return exp;
        }
        catch(ParseException exc) {
            throw new ExpressionParserException(exc.getMessage(),exc);
        }
    }

    private String clean(String prefix, String str) {
        str = str.trim();
        str = str.replaceAll("\n"+prefix,"\n");
        str = str.substring(prefix.length());
        return str;
    }

    public static void main(String args[]) {
        try {
            ExpressionParser parser = new NodeReaderJpel();
            boolean execute = Boolean.valueOf(args[0]).booleanValue();
            Environment env = (execute?EnvironmentBuilder.getEnvironmentFactory().produce():null);
            System.out.println("ENV>"+env);
            for (int i = 1; i < args.length; i++) {
                Expression exp = null;
                File f = new File(args[i]);
                if( f.exists() ) {
                    exp = parser.getExpression(new FileInputStream(f));
                }
                else {
                    exp = parser.getExpression(args[i]);
                }
                if( execute ) {
                    System.out.print("Result("+i+") "+exp+" = ");
                    System.out.println(exp.eval(env));
                }
                else {
                    System.out.println("Parsed("+i+") "+exp);
                }
            }
        }
        catch(Exception exc) {
            exc.printStackTrace();
        }
    }

  final public Node getNode(Include include) throws ParseException, NodeException, DataHolderFactoryException {
    Token description = null;
    String str = null;
    Node node = factory.getNode(include);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case FDESCRIPTION:
        ;
        break;
      default:
        jj_la1[0] = jj_gen;
        break label_1;
      }
      description = jj_consume_token(FDESCRIPTION);
            if ( str == null ) {
                str = description.toString();
            }
            else {
                str += description.toString();
            }
    }
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DESCRIPTION:
      case NATIVE:
      case MODULE:
      case INCLUDE:
      case ID:
        ;
        break;
      default:
        jj_la1[1] = jj_gen;
        break label_2;
      }
      getDeclaration(node);
    }
    jj_consume_token(0);
        if( str != null ) {
            include.setDescription(clean("#!",str));
        }
        {if (true) return node;}
    throw new Error("Missing return statement in function");
  }

  final public void getDeclaration(Node base) throws ParseException, NodeException, DataHolderFactoryException {
    Token description = null;
    String str = null;
    Declaration dec = null;
    Include inc = null;
    label_3:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DESCRIPTION:
        ;
        break;
      default:
        jj_la1[2] = jj_gen;
        break label_3;
      }
      description = jj_consume_token(DESCRIPTION);
            if ( str == null ) {
                str = description.toString();
            }
            else {
                str += description.toString();
            }
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case ID:
      dec = PFunction();
                factory.getNode(dec,base);
      break;
    case NATIVE:
      dec = PNative();
                factory.getNode(dec,base);
      break;
    case MODULE:
      dec = PModule(base);
      break;
    case INCLUDE:
      inc = PInclude();
                factory.getNode(inc,base);
      break;
    default:
      jj_la1[3] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        if( str != null ) {
            if( dec != null ) {
                dec.setDescription(clean("#",str));
            }
            else {
                inc.setDescription(clean("#",str));
            }
        }
  }

  final public Declaration PFunction() throws ParseException, NodeException {
  ExpressionId id;
  ExpressionList args = null;
  Expression body;
    id = PExpressionId();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
      jj_consume_token(LPAREN);
      args = PExpressionList();
      jj_consume_token(RPAREN);
      break;
    default:
      jj_la1[4] = jj_gen;
      ;
    }
    jj_consume_token(EQUALS);
    body = PExpression();
    jj_consume_token(SEMICOLON);
        if( args == null ) {
            args = new ExpressionListImpl();
        }
        Abstraction abs = new Abstraction(args,body);
        {if (true) return new DeclarationFunction(null,id,abs);}
    throw new Error("Missing return statement in function");
  }

  final public Declaration PNative() throws ParseException, NodeException {
  ExpressionId id;
  ExpressionList args = null;
  ExpressionId body;
    jj_consume_token(NATIVE);
    id = PExpressionId();
    jj_consume_token(LPAREN);
    args = PExpressionList();
    jj_consume_token(RPAREN);
    jj_consume_token(EQUALS);
    body = PExpressionId();
    jj_consume_token(SEMICOLON);
        try {
            Abstraction abs = new Abstraction(args,body);
            {if (true) return new DeclarationNative(null,id,abs);}
        }
        catch(DeclarationException exc) {
            {if (true) throw new NodeException(exc.getMessage(),exc);}
        }
    throw new Error("Missing return statement in function");
  }

  final public Declaration PModule(Node base) throws ParseException, NodeException, DataHolderFactoryException {
  ExpressionId id;
  Declaration dec;
  Node module;
    jj_consume_token(MODULE);
    id = PExpressionId();
        try {
            dec = new DeclarationModule(null,id,envFactory.empty());
        }
        catch(EnvironmentFactoryException exc) {
            {if (true) throw new NodeException(exc.getMessage(),exc);}
        }
        module = factory.getNode(dec,base);
    jj_consume_token(LBRACE);
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case DESCRIPTION:
      case NATIVE:
      case MODULE:
      case INCLUDE:
      case ID:
        ;
        break;
      default:
        jj_la1[5] = jj_gen;
        break label_4;
      }
      getDeclaration(module);
    }
    jj_consume_token(RBRACE);
        {if (true) return dec;}
    throw new Error("Missing return statement in function");
  }

  final public Include PInclude() throws ParseException, NodeException, DataHolderFactoryException {
  ExpressionString reference;
  ExpressionId name = null;
    jj_consume_token(INCLUDE);
    reference = PExpressionString();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case AS:
      jj_consume_token(AS);
      name = PExpressionId();
      break;
    default:
      jj_la1[6] = jj_gen;
      ;
    }
        DataHolder holder = holderFactory.produce( reference.asString() );
        {if (true) return new Include(holder,name);}
    throw new Error("Missing return statement in function");
  }

  final public Expression getExpression() throws ParseException {
    Expression first;
    first = PExpression();
    jj_consume_token(0);
        {if (true) return first;}
    throw new Error("Missing return statement in function");
  }

  final public Expression PExpression() throws ParseException {
    Expression first;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LPAREN:
    case LBRACKET:
    case NUMBER:
    case TRUE:
    case FALSE:
    case CHARACTER:
    case STRING:
    case ID:
      first = PBinaryExpression();
      break;
    case IF:
      first = PIfThenElse();
      break;
    case CASE:
      first = PSwitch();
      break;
    default:
      jj_la1[7] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
        {if (true) return first;}
    throw new Error("Missing return statement in function");
  }

  final public Expression PIfThenElse() throws ParseException {
    Expression condition, thenExpression, elseExpression;
    jj_consume_token(IF);
    condition = PExpression();
    jj_consume_token(THEN);
    thenExpression = PExpression();
    jj_consume_token(ELSE);
    elseExpression = PExpression();
        {if (true) return new ExpressionIfThenElse(condition,thenExpression,elseExpression);}
    throw new Error("Missing return statement in function");
  }

  final public Expression PSwitch() throws ParseException {
    ExpressionList conditions = new ExpressionListImpl();
    ExpressionList expressions = new ExpressionListImpl();
    Expression condition, expression;
    label_5:
    while (true) {
      jj_consume_token(CASE);
      condition = PExpression();
      jj_consume_token(EQUALS);
      expression = PExpression();
                conditions.append(condition);
                expressions.append(expression);
      if (jj_2_1(2147483647)) {
        ;
      } else {
        break label_5;
      }
    }
    jj_consume_token(CASE);
    jj_consume_token(OTHERWISE);
    jj_consume_token(EQUALS);
    expression = PExpression();
        {if (true) return new ExpressionSwitch(conditions,expressions,expression);}
    throw new Error("Missing return statement in function");
  }

  final public Expression PBinaryExpression() throws ParseException {
    Expression left, operator, right;
    left = PUnaryExpression();
    label_6:
    while (true) {
      if (jj_2_2(2147483647)) {
        ;
      } else {
        break label_6;
      }
      operator = PExpressionId();
      right = PUnaryExpression();
                    ExpressionList arguments = new ExpressionListImpl();
                    arguments.append(left);
                    arguments.append(right);
                    left = new ExpressionCall(operator,arguments);
    }
        {if (true) return left;}
    throw new Error("Missing return statement in function");
  }

  final public Expression PUnaryExpression() throws ParseException {
    Expression first, second;
    if (jj_2_3(2147483647)) {
      first = PExpressionId();
      jj_consume_token(LPAREN);
      second = PExpressionList();
      jj_consume_token(RPAREN);
                first = new ExpressionCall(first,(ExpressionList)second);
    } else if (jj_2_4(2147483647)) {
      jj_consume_token(LPAREN);
      first = PExpressionList();
      jj_consume_token(RPAREN);
    } else {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LPAREN:
        jj_consume_token(LPAREN);
        first = PExpression();
        jj_consume_token(RPAREN);
        break;
      case TRUE:
      case FALSE:
        first = PExpressionBoolean();
        break;
      case CHARACTER:
        first = PExpressionCharacter();
        break;
      case NUMBER:
        first = PExpressionNumber();
        break;
      case STRING:
        first = PExpressionString();
        break;
      case ID:
        first = PExpressionId();
        break;
      case LBRACKET:
        jj_consume_token(LBRACKET);
        first = PExpressionList();
        jj_consume_token(RBRACKET);
        break;
      default:
        jj_la1[8] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
        {if (true) return first;}
    throw new Error("Missing return statement in function");
  }

  final public ExpressionId PExpressionId() throws ParseException {
    Token token;
    token = jj_consume_token(ID);
        String name = token.toString().trim();
        {if (true) return new ExpressionId(name);}
    throw new Error("Missing return statement in function");
  }

  final public ExpressionBoolean PExpressionBoolean() throws ParseException {
    Token token;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case TRUE:
      token = jj_consume_token(TRUE);
        {if (true) return ExpressionBoolean.TRUE;}
      break;
    case FALSE:
      token = jj_consume_token(FALSE);
        {if (true) return ExpressionBoolean.FALSE;}
      break;
    default:
      jj_la1[9] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public ExpressionCharacter PExpressionCharacter() throws ParseException {
    Token token;
    token = jj_consume_token(CHARACTER);
        String str = token.toString().trim();
        str = ExpressionString.normalize(str);
        {if (true) return new ExpressionCharacter(str.charAt(1));}
    throw new Error("Missing return statement in function");
  }

  final public ExpressionNumber PExpressionNumber() throws ParseException {
    Token token;
    token = jj_consume_token(NUMBER);
        {if (true) return new ExpressionNumber(token.toString().trim());}
    throw new Error("Missing return statement in function");
  }

  final public ExpressionString PExpressionString() throws ParseException {
    Token token;
    token = jj_consume_token(STRING);
        String str = token.toString().trim();
        str = ExpressionString.normalize(str);
        {if (true) return new ExpressionString(str.substring(1,str.length()-1));}
    throw new Error("Missing return statement in function");
  }

  final public ExpressionList PExpressionList() throws ParseException {
    Expression first;
    ExpressionList list = new ExpressionListImpl();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IF:
    case CASE:
    case LPAREN:
    case LBRACKET:
    case NUMBER:
    case TRUE:
    case FALSE:
    case CHARACTER:
    case STRING:
    case ID:
      first = PExpression();
            list.append(first);
      label_7:
      while (true) {
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case COMMA:
          ;
          break;
        default:
          jj_la1[10] = jj_gen;
          break label_7;
        }
        jj_consume_token(COMMA);
        first = PExpression();
                list.append(first);
      }
      break;
    default:
      jj_la1[11] = jj_gen;
      ;
    }
        {if (true) return list;}
    throw new Error("Missing return statement in function");
  }

  final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_1();
    jj_save(0, xla);
    return retval;
  }

  final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_2();
    jj_save(1, xla);
    return retval;
  }

  final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_3();
    jj_save(2, xla);
    return retval;
  }

  final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    boolean retval = !jj_3_4();
    jj_save(3, xla);
    return retval;
  }

  final private boolean jj_3R_13() {
    if (jj_3R_26()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_9() {
    if (jj_scan_token(ID)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_25() {
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_33()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_12() {
    if (jj_3R_25()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_4() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_30() {
    if (jj_scan_token(NUMBER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_23() {
    if (jj_scan_token(LBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RBRACKET)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_22() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_1() {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_21() {
    if (jj_3R_31()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_12()) {
    jj_scanpos = xsp;
    if (jj_3R_13()) {
    jj_scanpos = xsp;
    if (jj_3R_14()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_20() {
    if (jj_3R_30()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_19() {
    if (jj_3R_29()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_3() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_18() {
    if (jj_3R_28()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_17() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_32() {
    if (jj_scan_token(COMMA)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_16() {
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_34() {
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_29() {
    if (jj_scan_token(CHARACTER)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_15() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(LPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_11()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(RPAREN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_27() {
    Token xsp;
    if (jj_3R_34()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_34()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    if (jj_scan_token(CASE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(OTHERWISE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(EQUALS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_24() {
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3R_32()) { jj_scanpos = xsp; break; }
      if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    }
    return false;
  }

  final private boolean jj_3R_10() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_15()) {
    jj_scanpos = xsp;
    if (jj_3R_16()) {
    jj_scanpos = xsp;
    if (jj_3R_17()) {
    jj_scanpos = xsp;
    if (jj_3R_18()) {
    jj_scanpos = xsp;
    if (jj_3R_19()) {
    jj_scanpos = xsp;
    if (jj_3R_20()) {
    jj_scanpos = xsp;
    if (jj_3R_21()) {
    jj_scanpos = xsp;
    if (jj_3R_22()) {
    jj_scanpos = xsp;
    if (jj_3R_23()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3_2() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_24()) jj_scanpos = xsp;
    else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_36() {
    if (jj_scan_token(FALSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_35() {
    if (jj_scan_token(TRUE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_28() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_35()) {
    jj_scanpos = xsp;
    if (jj_3R_36()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_33() {
    if (jj_3R_9()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_10()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_26() {
    if (jj_scan_token(IF)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(THEN)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_scan_token(ELSE)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_31() {
    if (jj_scan_token(STRING)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  final private boolean jj_3R_14() {
    if (jj_3R_27()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  public NodeReaderJpelTokenManager token_source;
  JavaCharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private Token jj_scanpos, jj_lastpos;
  private int jj_la;
  public boolean lookingAhead = false;
  private boolean jj_semLA;
  private int jj_gen;
  final private int[] jj_la1 = new int[12];
  final private int[] jj_la1_0 = {0x200000,0x7400000,0x400000,0x7000000,0x4000,0x7400000,0x8000000,0x10014900,0x10014000,0x0,0x2000,0x10014900,};
  final private int[] jj_la1_1 = {0x0,0x80,0x0,0x80,0x0,0x80,0x0,0xbc,0xbc,0xc,0x0,0xbc,};
  final private JJCalls[] jj_2_rtns = new JJCalls[4];
  private boolean jj_rescan = false;
  private int jj_gc = 0;

  public NodeReaderJpel(java.io.InputStream stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new NodeReaderJpelTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public NodeReaderJpel(java.io.Reader stream) {
    jj_input_stream = new JavaCharStream(stream, 1, 1);
    token_source = new NodeReaderJpelTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public NodeReaderJpel(NodeReaderJpelTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(NodeReaderJpelTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 12; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    return (jj_scanpos.kind != kind);
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;
  private int[] jj_lasttokens = new int[100];
  private int jj_endpos;

  private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration enum = jj_expentries.elements(); enum.hasMoreElements();) {
        int[] oldentry = (int[])(enum.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[43];
    for (int i = 0; i < 43; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 12; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 43; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

  final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 4; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
