package jpel.gui.bridge;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.awt.Dimension;
import java.awt.Toolkit;

import jpel.gui.util.Icons;

public class ApplicationMain {
    private boolean packFrame = false;

    //Construct the application
    public ApplicationMain() {
        FrameMain frame = new FrameMain();
        frame.setIconImage(Icons.CONVERT.getImage());
        //Validate frames that have preset sizes
        //Pack frames that have useful preferred size info, e.g. from their layout
        if(packFrame) {
            frame.pack();
        }
        else {
            frame.validate();
        }
        /*
                //Center the window
             Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
                Dimension frameSize = frame.getSize();
                if (frameSize.height > screenSize.height) {
                    frameSize.height = screenSize.height;
                }
                if (frameSize.width > screenSize.width) {
                    frameSize.width = screenSize.width;
                }
                frame.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
                frame.setVisible(true);
         */
        Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
        int gap = 40;
        frame.setSize((int) screenSize.getWidth() - 2 * gap,
            (int) screenSize.getHeight() - 2 * gap);
        frame.setLocation(gap, gap);
        frame.setVisible(true);
    }

    //Main method
    public static void main(String[] args) {
        try {
        //UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        }
        catch(Exception e) {
            e.printStackTrace();
        }
        new ApplicationMain();
    }
}
