package jpel.gui.bridge;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import javax.swing.JCheckBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;

import jpel.bridge.NodeMatcherEnvironment;
import jpel.language.Environment;
import jpel.tree.NodeBuilder;
import jpel.tree.NodeException;
import jpel.tree.NodeMatcher;

public class NodeMatcherPanel extends JPanel {
    private NodeMatcher matcher;
    private JLabel jLabelTop = new JLabel();
    private JTextField jTextFieldRE = new JTextField();
    private JCheckBox jCheckBoxRecursive = new JCheckBox();
    private GridBagLayout gridBagLayout1 = new GridBagLayout();
    private JCheckBox jCheckBoxName = new JCheckBox();
    private JCheckBox jCheckBoxBody = new JCheckBox();
    private JCheckBox jCheckBoxDescription = new JCheckBox();

    public NodeMatcherPanel() throws ClassNotFoundException {
        matcher = NodeBuilder.lookupNodeMatcher(Environment.class.getName());
        try {
            jbInit();
        }
        catch(Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        jLabelTop.setText("Search for:");
        jCheckBoxRecursive.setSelected(true);
        jCheckBoxRecursive.setText("Dependency");
        this.setLayout(gridBagLayout1);
        jCheckBoxName.setSelected(true);
        jCheckBoxName.setText("Name");
        jCheckBoxBody.setText("Body");
        jCheckBoxDescription.setText("Description");
        this.add(jLabelTop, new GridBagConstraints(0, 0, 4, 1, 1.0, 0.0
            , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(5, 5, 0, 0), 0, 0));
        this.add(jTextFieldRE, new GridBagConstraints(0, 1, 4, 1, 0.0, 0.0
            , GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL,
            new Insets(5, 5, 0, 5), 0, 0));
        this.add(jCheckBoxName, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0,
            0, 0, 0), 0, 0));
        this.add(jCheckBoxBody, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0,
            0, 0, 0), 0, 0));
        this.add(jCheckBoxDescription, new GridBagConstraints(2, 2, 1, 1, 0.0,
            0.0
            , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0,
            0, 0, 0), 0, 0));
        this.add(jCheckBoxRecursive, new GridBagConstraints(3, 2, 1, 1, 0.0,
            0.0
            , GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL,
            new Insets(0, 5, 5, 5), 0, 0));
    }

    public NodeMatcher getMatcher() throws NodeException {
        if(matcher instanceof NodeMatcherEnvironment) {
            NodeMatcherEnvironment m = (NodeMatcherEnvironment) matcher;
            m.setUseName(jCheckBoxName.isSelected());
            m.setUseBody(jCheckBoxBody.isSelected());
            m.setUseDescription(jCheckBoxDescription.isSelected());
            m.setRecursive(jCheckBoxRecursive.isSelected());
            m.setPattern(jTextFieldRE.getText());
        }
        return matcher;
    }
}
