package jpel.gui.language;


import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionParser;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

public class JPaneEnvironment extends JPanel {
    private ExpressionParser parser;
    private Environment environment;

    private JScrollPane jScrollPane2 = new JScrollPane();
    private JTextArea jTextAreaIn = new JTextArea();
    private JPanel jPanel1 = new JPanel();
    private JScrollPane jScrollPane3 = new JScrollPane();
    private JTextArea jTextAreaOut = new JTextArea();
    private JSplitPane jSplitPane1 = new JSplitPane();
    private JSplitPane jSplitPane2 = new JSplitPane();
    private JPanel jPanel2 = new JPanel();
    private BorderLayout borderLayout1 = new BorderLayout();
    private BorderLayout borderLayout3 = new BorderLayout();
    private BorderLayout borderLayout2 = new BorderLayout();
    private JPanel jPanel3 = new JPanel();
    private JButton jButtonExecute = new JButton();
    private FlowLayout flowLayout1 = new FlowLayout();
    protected JPanel jPanel4 = new JPanel();
    protected JTreeEnvironment jTreeEnvironment = new JTreeEnvironment();
    protected JScrollPane jScrollPane1 = new JScrollPane();
    protected GridBagLayout gridBagLayout1 = new GridBagLayout();
    protected JCheckBox jCheckBoxShowJVM = new JCheckBox();
    protected JCheckBox jCheckBoxShowLang = new JCheckBox();

    public JPaneEnvironment() {
        try {
            jbInit();
        }
        catch( Exception e ) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.setLayout( borderLayout3 );
        jPanel1.setLayout( borderLayout2 );
        jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT );
        jSplitPane1.setLastDividerLocation( 100 );
        jSplitPane1.setResizeWeight( 0.5 );
        jPanel2.setLayout( borderLayout1 );
        jSplitPane2.setOrientation( JSplitPane.VERTICAL_SPLIT );
        jSplitPane2.setResizeWeight( 0.5 );
        jButtonExecute.setText( "Execute" );
        jButtonExecute.addActionListener( new java.awt.event.ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                jButtonExecute_actionPerformed( e );
            }
        } );
        jPanel3.setLayout( flowLayout1 );
        flowLayout1.setAlignment( FlowLayout.LEFT );
        flowLayout1.setHgap( 2 );
        flowLayout1.setVgap( 2 );
        jTextAreaIn.setFont( new java.awt.Font( "Monospaced", 0, 12 ) );
        jTextAreaOut.setFont( new java.awt.Font( "Monospaced", 0, 12 ) );
        jPanel4.setLayout(gridBagLayout1);
        jCheckBoxShowJVM.setText("Show JVM");
        jCheckBoxShowJVM.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                jCheckBoxShowJVM_itemStateChanged(e);
            }
        });
        jCheckBoxShowLang.setText("Show lang");
        jCheckBoxShowLang.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                jCheckBoxShowLang_itemStateChanged(e);
            }
        });
        this.add( jSplitPane1, BorderLayout.CENTER );
        jSplitPane2.add( jScrollPane2, JSplitPane.LEFT );
        jSplitPane2.add( jPanel2, JSplitPane.RIGHT );
        jPanel2.add( jPanel1, BorderLayout.CENTER );
        jScrollPane2.getViewport().add( jTextAreaIn, null );
        jPanel1.add( jScrollPane3, BorderLayout.CENTER );
        jPanel1.add( jPanel3, BorderLayout.NORTH );
        jPanel3.add( jButtonExecute, null );
        jSplitPane1.add(jPanel4, JSplitPane.TOP);
        jPanel4.add(jScrollPane1,     new GridBagConstraints(0, 1, 2, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 1, 1));
        jPanel4.add(jCheckBoxShowJVM,   new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        jPanel4.add(jCheckBoxShowLang, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
        jScrollPane1.getViewport().add(jTreeEnvironment, null);
        jScrollPane3.getViewport().add( jTextAreaOut, null );
        jSplitPane1.add( jSplitPane2, JSplitPane.BOTTOM );
    }

    public void setEnvironment( Environment environment ) throws
        ExecutionException {
        jTreeEnvironment.setEnvironment( environment );
        jTreeEnvironment.expandAll();
        this.environment = environment;
    }

    public Environment getEnvironment() {
        return environment;
    }

    public void setParser( ExpressionParser parser ) {
        this.parser = parser;
    }

    public ExpressionParser getParser() {
        return parser;
    }

    void jButtonExecute_actionPerformed( ActionEvent e ) {
        if( environment != null && parser != null ) {
            try {
                Expression expression = parser.getExpression( jTextAreaIn.
                                        getText() );
                Expression result = expression.eval( environment );
                jTextAreaOut.setText( String.valueOf( result ) );
            }
            catch( Exception exc ) {
                exc.printStackTrace();
                JOptionPane.showMessageDialog( this, exc.getMessage(), "Error",
                    JOptionPane.ERROR_MESSAGE );
            }
        }
        else {
            JOptionPane.showMessageDialog( this,
                "You must setup the environment and the parser.", "Error",
                JOptionPane.ERROR_MESSAGE );
        }
    }

    void jCheckBoxShowLang_itemStateChanged(ItemEvent e) {
        try {
            jTreeEnvironment.setShowLang(jCheckBoxShowLang.isSelected());
            if( environment != null ) {
                setEnvironment( this.environment );
            }
        }
        catch( Exception exc ) {
            exc.printStackTrace();
            JOptionPane.showMessageDialog( this, "Unable to show lang operators.\n"+exc.getMessage(), "Error",
                JOptionPane.ERROR_MESSAGE );
        }
    }

    void jCheckBoxShowJVM_itemStateChanged(ItemEvent e) {
        try {
            jTreeEnvironment.setShowJvm(jCheckBoxShowJVM.isSelected());
            if( environment != null ) {
                setEnvironment( this.environment );
            }
        }
        catch( Exception exc ) {
            exc.printStackTrace();
            JOptionPane.showMessageDialog( this, "Unable to show JVM parameters.\n"+exc.getMessage(), "Error",
                JOptionPane.ERROR_MESSAGE );
        }
    }

}
