package jpel.gui.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;

import javax.swing.JFileChooser;

import jpel.gui.util.Utils;
import jpel.tree.NodeBuilder;
import jpel.tree.NodeReader;

public class UtilsNode {

    private static JFileChooser fileChooser;

    public static final JFileChooser getNodeFileChooser() {
        if( fileChooser == null ) {
            HashMap map = new HashMap();
            Iterator iter = NodeBuilder.readerTypes();
            while( iter.hasNext() ) {
                try {
                    String type = ( String ) iter.next();
                    NodeReader reader = NodeBuilder.lookupNodeReader( type );
                    String description = reader.getDescription();
                    LinkedList types = ( LinkedList ) map.get( description );
                    if( types == null ) {
                        types = new LinkedList();
                        map.put( description, types );
                    }
                    types.add( type );
                }
                catch( ClassNotFoundException ex ) {
                    ex.printStackTrace();
                }
            }

            String[] names = new String[map.size()];
            map.keySet().toArray( names );

            String[][] types = new String[map.size()][];
            iter = map.keySet().iterator();
            for( int i = 0; iter.hasNext(); i++ ) {
                LinkedList list = ( LinkedList ) map.get( iter.next() );
                String[] sub = new String[list.size()];
                list.toArray( sub );
                types[i] = sub;
            }
            fileChooser = Utils.getDefaultFileChooser( types, names );
            fileChooser.setMultiSelectionEnabled( true );
        }
        return fileChooser;
    }

}
