package jpel.gui.util;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.Vector;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JMenuBar;

public class JMenuBarGroup extends JMenuBar implements ActionListener {

    transient private Vector actionListeners;

    public JMenuBarGroup() {
        super();
    }

    public void addGroup( String name, JMenuGroup group ) {
        group.setText( name );
        group.addActionListener( this );
        add( group, name );
    }

    public void actionPerformed( ActionEvent e ) {
        fireActionPerformed( e );
    }

    public synchronized void removeActionListener( ActionListener l ) {
        if( actionListeners != null && actionListeners.contains( l ) ) {
            Vector v = ( Vector ) actionListeners.clone();
            v.removeElement( l );
            actionListeners = v;
        }
    }

    public synchronized void addActionListener( ActionListener l ) {
        Vector v = actionListeners == null ? new Vector( 2 )
                   : ( Vector ) actionListeners.clone();
        if( !v.contains( l ) ) {
            v.addElement( l );
            actionListeners = v;
        }
    }

    protected void fireActionPerformed( ActionEvent e ) {
        if( actionListeners != null ) {
            Vector listeners = actionListeners;
            int count = listeners.size();
            for( int i = 0; i < count; i++ ) {
                ( ( ActionListener ) listeners.elementAt( i ) ).actionPerformed(
                    e );
            }
        }
    }
}
