package jpel.gui.util;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;

public class Utils {

    private static class FileFilterImpl extends FileFilter {
        private String[] extensions;
        private String description;

        public FileFilterImpl( String[] extensions, String description ) {
            this.extensions = extensions;
            this.description = description;
        }

        public boolean accept( File file ) {
            boolean result = file.isDirectory();
            String name = file.getName();
            for( int i = 0; !result && i < extensions.length; i++ ) {
                result = name.endsWith( extensions[i] );
            }
            return result;
        }

        public String getDescription() {
            return description;
        }
    }

    public static final JFileChooser getDefaultFileChooser( String[][]
        extensions, String[] names ) {
        JFileChooser fileChooser = new JFileChooser( new File(System.getProperty("user.dir")) );
        if( extensions != null && names != null ) {
            for( int i = 0; i < extensions.length; i++ ) {
                fileChooser.addChoosableFileFilter( new FileFilterImpl(
                    extensions[i], names[i] ) );
            }
        }
        return fileChooser;
    }
}
