package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Classe usada como referncia para implementao de qualquer declarao.
 */
public abstract class AbstractDeclaration implements Declaration {

    private String description;
    private DeclarationType type;
    private ExpressionId module;
    private ExpressionId name;

    public AbstractDeclaration(DeclarationType type, ExpressionId module,
        ExpressionId name) {
        setType(type);
        setModule(module);
        setName(name);
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public void setType(DeclarationType type) {
        this.type = type;
    }

    public DeclarationType getType() {
        return type;
    }

    public void setModule(ExpressionId module) {
        this.module = module;
    }

    public ExpressionId getModule() {
        return module;
    }

    public void setName(ExpressionId name) {
        this.name = name;
    }

    public ExpressionId getName() {
        return name;
    }
}
