package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

/**
 * Classe usada como referncia para implementao de qualquer expresso.
 */
public abstract class AbstractExpression implements Expression {

    private Object source;
    private Object data;
    private ExpressionType type;

    public AbstractExpression(ExpressionType type) {
        setType(type);
    }

    public void setSource(Object source) {
        this.source = source;
    }

    public Object getSource() {
        return source;
    }

    public void setData(Object data) {
        this.data = data;
    }

    public Object getData() {
        return data;
    }

    public Object getData(Class type) {
        return data;
    }

    public void setType(ExpressionType type) {
        this.type = type;
    }

    public ExpressionType getType() {
        return type;
    }

    public Expression createClone() {
        return rebuild(new MapReplaceImpl());
    }

    public boolean equivalent( Expression exp ) {
        return false;
    }

    public String toString() {
        return(getData() != null ? String.valueOf(getData())
            : getClass().getName());
    }
}
