package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Permite que expresses possuam uma relao de ordem. Esta interface  usada
 * na definio das comparaes.
 */
public interface ComparableExpression extends Expression {

    /**
     * Indicates a order relation throught instances of the same type.
     * @param exp - The expression to be compared
         * @return -1 if it comes before then the give expression, 0 if is in the same
     * leve, and 1 otherwise.
     * @throws BadTypedException When a wrong comparation type is passed.
     */
    int compareTo(ComparableExpression expression) throws
        BadTypedException;
}
