package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Caracteriza os erros gerados durante execuo de uma declaracao.
 */
public class DeclarationException extends Exception {

    private Declaration declaration;

    public DeclarationException(Declaration source) {
        this(source, null, null);
    }

    public DeclarationException(Declaration source, String message) {
        this(source, message, null);
    }

    public DeclarationException(Declaration source, String message,
        Throwable detail) {
        super(message, detail);
        this.declaration = source;
    }

    public Declaration getDeclaration() {
        return declaration;
    }
}
