package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Classe que permite a adio de funes ao ambiente de execuo.
 */
public class DeclarationFunction extends AbstractDeclaration {

    private Abstraction abstraction;

    public DeclarationFunction(ExpressionId module, ExpressionId name,
        Abstraction abstraction) {
        this(DeclarationType.FUNCTION, module, name, abstraction);
    }

    public DeclarationFunction(DeclarationType type, ExpressionId module,
        ExpressionId name, Abstraction abstraction) {
        super(type, module, name);
        setAbstraction(abstraction);
    }

    public void setAbstraction(Abstraction abstraction) {
        this.abstraction = abstraction;
    }

    public Abstraction getAbstraction() {
        return abstraction;
    }

    public void execute(Environment environment) throws DeclarationException {
        if(getModule() != null) {
            try {
                environment = (Environment) environment.lookupSub(
                              getModule());
            }
            catch(IdNotFoundException ex) {
                throw new DeclarationException(this, ex.getMessage(), ex);
            }
        }
        environment.bind(getName(), abstraction);
    }

    public Declaration rebuild(MapReplace map) {
        Declaration dec = new DeclarationFunction(getType(), getModule(),
                          getName(), (Abstraction) getAbstraction().rebuild(map));
        dec.setDescription(getDescription());
        return dec;
    }

}
