package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

/**
 * Define uma fbrica de ambientes da linguagem. Podendo produzir ambientes com
 * funces predefinida, no caso padro temos uma fbrica que poduz ambiente com
 * operaes aritmticas, relacionais e sobre listas.
 */
public interface EnvironmentFactory {

    /**
     * Indica se um identificador faz parte da lista de operadores padro.
     * @param id O identificador.
     * @return true, caso seja operador padro, false, caso contrrio.
     */
    boolean isLang(ExpressionId id);

    /**
     * Retorna um ambiente vazio para a execuao de expresses.
     * @return O ambiente.
         * @throws EnvironmentFactoryException Quando h erro na criao do ambiente.
     */
    Environment empty() throws EnvironmentFactoryException;

    /**
     * Retorna um ambiente para execuo de expresses.
     * @return O ambiente.
         * @throws EnvironmentFactoryException Quando h erro na criao do ambiente.
     */
    Environment produce() throws EnvironmentFactoryException;

}
