package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.GenericTool;

/**
 * Define o processo de carga de um ambiente em memria.
 */
public interface EnvironmentLoader extends GenericTool {

    /**
     * Carrega um ambiente.
     * @param source Fonte de dados, ou meta-informaes de como carregar o
     * ambiente.
     * @return Um ambiente da linguagem funcional.
     * @throws EnvironmentLoaderException Quando h problemas na leitura do
     * ambiente.
     */
    Environment load(Object source) throws EnvironmentLoaderException;

}