package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Caracteriza os erros gerados durante execuo de uma expresso.
 */
public class ExecutionException extends Exception {

    private Expression expression;

    public ExecutionException(Expression source) {
        this(source, null, null);
    }

    public ExecutionException(Expression source, String message) {
        this(source, message, null);
    }

    public ExecutionException(Expression source, String message,
        Throwable detail) {
        super(message, detail);
        this.expression = source;
    }

    public Expression getExpression() {
        return expression;
    }
}
