package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

import jpel.util.Debugger;

/**
 * Classe utilitria para a criao de dinmica dos elementos da linguagem.
 */
public class ExpressionBuilder {

    private static final String JVM_PARAMETER = "expressionParser";

    public static ExpressionParser getExpressionParser() throws
        ClassNotFoundException, IllegalAccessException, InstantiationException {
        String classType = System.getProperty(JVM_PARAMETER,
                           "jpel.bridge.NodeReaderJpel");
        return getExpressionParser(classType);
    }

    public static ExpressionParser getExpressionParser(String classType) throws
        ClassNotFoundException, IllegalAccessException, InstantiationException {
        ExpressionParser parser = (ExpressionParser) Class.forName(classType).
                                  newInstance();
        Debugger.println("ExpressionBuilder", "parser",
            "Class>" + parser.getClass().getName());
        return parser;
    }

    public static void main(String[] args) {
        try {
            ExpressionParser obj = ExpressionBuilder.getExpressionParser();
            if(obj != null) {
                System.out.println("Parser is a instance of '"
                    + obj.getClass().getName() + "'.");
            }
            else {
                System.out.println("Parser is null.");
            }
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}
