package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Indica o tipo character da linguagem.
 */
public class ExpressionCharacter extends ExpressionObject implements
    StringableExpression, ComparableExpression {

    public ExpressionCharacter(char value) {
        this(new Character(value));
    }

    public ExpressionCharacter(Character value) {
        super(ExpressionType.CHARACTER, value);
    }

    public char getChar() {
        return((Character) getData(Character.class)).charValue();
    }

    public String asString() {
        return String.valueOf(getData(Character.class));
    }

    public int compareTo(ComparableExpression expression) throws
        BadTypedException {
        if(!expression.getType().isCharacter()) {
            throw new BadTypedException(expression,
                this +" can not be compared to " + expression);
        }
        ExpressionCharacter exp = (ExpressionCharacter) expression;
        return getChar() - exp.getChar();
    }

    public String toString() {
        return "\'" + asString() + "\'";
    }
}