package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 *  um gerador de identificadores.
 */
public class ExpressionIdFactory {

    private static int count = 0;
    private static ExpressionId id = new ExpressionId(""
                                     + System.currentTimeMillis());

    /**
     * Fornece um identificador.
     * @return Um identificador cujo prefixo  a data do sistema, concatenado com um nmero
     * de srie nico.
     */
    public static ExpressionId produce() {
        return produce(id);
    }

    /**
     * Fornece um identificador nico baseado no identificador fornecido.
     * @param id Identificador usado como referncia.
     * @return Um novo identificador.
     */
    public static ExpressionId produce(ExpressionId id) {
        return new ExpressionId("_" + id.getName() + "_" + count++);
    }
}
