package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.Iterator;

/**
 * Implementao do iterator que trabalha com objetos do tipo ExpressionList.
 */
public class ExpressionListIterator implements Iterator {
    private ExpressionList source;
    private ExpressionList cursor;

    public ExpressionListIterator(ExpressionList source) {
        this.source = source;
        this.cursor = this.source;
    }

    public void reset() {
        cursor = source;
    }

    public boolean hasNext() {
        return(cursor != null ? cursor.head() != null : false);
    }

    public Object next() {
        Object obj = null;
        if(cursor != null) {
            obj = cursor.head();
            cursor = cursor.tail();
        }
        return obj;
    }

    public void remove() {
        next();
    }
}
