package jpel.language;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
     * Representa uma expresso que oissui um objeto qualquer agregado.  esta classe
     * que deve ser extendida quando se deseja icrementar a linguagem com novos tipos
 * de expresses.
 */
public class ExpressionObject extends AbstractExpression {

    public ExpressionObject(Object value) {
        this(ExpressionType.OBJECT, value);
    }

    public ExpressionObject(ExpressionType type, Object value) {
        super(type);
        setData(value);
    }

    public void freeVariable(ExpressionList list) {}

    public Expression rebuild(MapReplace map) {
        return this;
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        return this;
    }

    public boolean equivalent(Expression expression) {
        boolean result = false;
        if(expression instanceof ExpressionObject) {
            Object data = expression.getData();
            return getData() == null ? data == null : getData().equals(data);
        }
        return result;
    }
}
