package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

import java.io.InputStream;
import java.io.Reader;

/**
 * Define um parser para expressoes.
 */
public interface ExpressionParser {

    /**
     * Retorna a expresso contida em uma String.
     * @param dataExpression A String que contem a expresso.
     * @return A expressao correspondente  String.
     * @throws ExpressionParserException Quando h erros na converso dos
     * dados em uma expresso.
     */
    Expression getExpression(String dataExpression) throws
        ExpressionParserException;

    /**
     * Retorna a expresso contida em um InputStream.
     * @param dataExpression O InputStream que contem a expresso.
     * @return A expressao correspondente ao InputStream.
     * @throws ExpressionParserException Quando h erros na converso dos
     * dados em uma expresso.
     */
    Expression getExpression(InputStream dataExpression) throws
        ExpressionParserException;

    /**
     * Retorna a expresso contida em um Reader.
     * @param dataExpression O Reader que contem a expresso.
     * @return A expressao correspondente ao Reader.
     * @throws ExpressionParserException Quando h erros na converso dos
     * dados em uma expresso.
     */
    Expression getExpression(Reader dataExpression) throws
        ExpressionParserException;
}
