package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.dataholder.DataHolder;

/**
 * Classe que permite as declaraes de includes dentro da linguagem.
 */
public class Include {

    private DataHolder holder;
    private ExpressionId name;
    private String description;

    /**
     * Construtor usado para a criao da relao de import na linguagem.
     * @param module Mdulo que est importando outro.
     * @param holder Fonte de dados para a incluso.
     */
    public Include(DataHolder holder, ExpressionId name) {
        setHolder(holder);
        setName(name);
    }

    public void setHolder(DataHolder holder) {
        this.holder = holder;
    }

    public DataHolder getHolder() {
        return holder;
    }

    public void setName(ExpressionId name) {
        this.name = name;
    }

    public ExpressionId getName() {
        return name;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }

    public String toString() {
        return "Include(" + holder.getReference() + "," + name + ")";
    }
}
