package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.HashMap;
import java.util.Iterator;

/**
 * Implementao padro do mapeamento de substituio.
 */
public class MapReplaceImpl implements MapReplace {

    private HashMap hash;

    public MapReplaceImpl() {
        hash = new HashMap();
    }

    public void put(Expression before, Expression after) {
        hash.put(before, after);
    }

    public Expression get(Expression expression) {
        return(Expression) hash.get(expression);
    }

    public void remove(Expression remove) {
        hash.remove(remove);
    }

    public Iterator keys() {
        return hash.keySet().iterator();
    }

    public MapReplace mirror() {
        MapReplaceImpl map = new MapReplaceImpl();
        Iterator i = hash.keySet().iterator();
        while(i.hasNext()) {
            Expression aux = (Expression) i.next();
            map.put(aux, (Expression) hash.get(aux));
        }
        return map;
    }

    public String toString() {
        return hash.toString();
    }

    public static void main(String[] args) {
        try {
            MapReplace map = new MapReplaceImpl();
            ExpressionId a = new ExpressionId("a");
            ExpressionId b = new ExpressionId("b");
            ExpressionId c = new ExpressionId("c");
            map.put(a, b);
            map.put(b, c);
            System.out.println("get(" + a + ")=" + map.get(a));
            System.out.println("get(" + b + ")=" + map.get(b));
        }
        catch(Exception ex) {
            ex.printStackTrace();
        }
    }
}
