package jpel.language;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Representa uma expresso que possui apenas um operando.
 */
public abstract class UnaryExpression extends AbstractNamedExpression {

    private Expression expression;

    public UnaryExpression(String unaryOperator, ExpressionType type,
        Expression expression) {
        super(type, unaryOperator);
        setExpression(expression);
    }

    public void setExpression(Expression expression) {
        this.expression = expression;
    }

    public Expression getExpression() {
        return expression;
    }

    public void freeVariable(ExpressionList list) {
        getExpression().freeVariable(list);
    }

    public boolean equivalent(Expression expression) {
        boolean result = false;
        if(expression instanceof UnaryExpression) {
            UnaryExpression e = (UnaryExpression) expression;
            result = getName().equals(e.getName());
            result = result && getExpression().equivalent(e.getExpression());
        }
        return result;
    }

    public String toString() {
        return getName() + " (" + getExpression() + ")";
    }
}
