package jpel.language.extensions;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionList;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;
import jpel.language.UnaryExpression;
import jpel.util.Debugger;

/**
 * N faz nada o valor de retorno  o mesmo passado como argumento. A funo
 * do echo  apenas escrever a expresso argumento no log do processo, para
 * acompanhamento da execuo.
 */
public class ExpressionEcho extends UnaryExpression {

    public ExpressionEcho(Expression expression) {
        this("echo", expression);
    }

    public ExpressionEcho(String id, Expression expression) {
        super(id, ExpressionType.STRING, expression);
    }

    public void freeVariable(ExpressionList list) {
        getExpression().freeVariable(list);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Debugger.println("Echo", "expression", String.valueOf(getExpression()));
        return getExpression();
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionEcho(getName(), getExpression().rebuild(novo));
    }
}