package jpel.language.extensions;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.AbstractNamedExpression;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionList;
import jpel.language.ExpressionNumber;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;

/**
 * Retorna o tempo do sistema em milisegundos, no momento da avaliao da
 * expresso.
 */

public class ExpressionTime extends AbstractNamedExpression {

    public ExpressionTime(String id) {
        super(ExpressionType.NUMBER, id);
    }

    public void freeVariable(ExpressionList list) {}

    public Expression rebuild(MapReplace map) {
        return this;
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        return new ExpressionNumber(System.currentTimeMillis());
    }

    public boolean equivalent(Expression expression) {
        return(expression instanceof ExpressionTime);
    }
}
