package jpel.language.operators;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.BinaryExpression;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionList;
import jpel.language.ExpressionListImpl;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;

/**
 * Adiciona uma expresso a uma lista.
 */
public class ExpressionCons extends BinaryExpression {

    public ExpressionCons(Expression left, Expression right) {
        this(":", left, right);
    }

    public ExpressionCons(String identity, Expression left, Expression right) {
        super(identity, ExpressionType.LIST, left, right);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Expression l = getLeftExpression().eval(environment);
        Expression r = getRightExpression().eval(environment);
        ExpressionList list = new ExpressionListImpl();
        if(l instanceof ExpressionList) {
            list.append((ExpressionList) l);
        }
        else {
            list.append(l);
        }
        if(r instanceof ExpressionList) {
            list.append((ExpressionList) r);
        }
        else {
            list.append(r);
        }
        return list.eval(environment);
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionCons(getName(),
            getLeftExpression().rebuild(novo),
            getRightExpression().rebuild(novo));
    }
}
