package jpel.language.operators;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.BinaryExpression;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;

/**
 * Operao maior ou igual.
 */
public class ExpressionGreaterEquals extends BinaryExpression {

    public ExpressionGreaterEquals(Expression left, Expression right) {
        this(">=", left, right);
    }

    public ExpressionGreaterEquals(String identity, Expression left,
        Expression right) {
        super(identity, ExpressionType.BOOLEAN, left, right);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Expression lesser = new ExpressionGreater(getLeftExpression(),
                            getRightExpression());
        Expression equals = new ExpressionEquals(getLeftExpression(),
                            getRightExpression());
        Expression exp = new ExpressionOr(lesser, equals);
        return exp.eval(environment);
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionGreaterEquals(getName(),
            getLeftExpression().rebuild(novo),
            getRightExpression().rebuild(novo));
    }
}
