package jpel.language.operators;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.BinaryExpression;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionBoolean;
import jpel.language.MapReplace;

/**
 * Operao mximo.
 */
public class ExpressionMax extends BinaryExpression {

    public ExpressionMax(Expression left, Expression right) {
        this("max", left, right);
    }

    public ExpressionMax(String identity, Expression left, Expression right) {
        super(identity, left.getType(), left, right);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Expression l = getLeftExpression().eval(environment);
        Expression r = getRightExpression().eval(environment);
        ExpressionGreater exp = new ExpressionGreater(l, r);
        if(((ExpressionBoolean) exp.eval(environment)).getBoolean()) {
            return l;
        }
        else {
            return r;
        }
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionMax(getName(),
            getLeftExpression().rebuild(novo),
            getRightExpression().rebuild(novo));
    }
}
