package jpel.language.operators;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.BadTypedException;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionNumber;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;
import jpel.language.UnaryExpression;

/**
 * Operao de negao de numeros.
 */
public class ExpressionNegative extends UnaryExpression {

    public ExpressionNegative(Expression expression) {
        this("-", expression);
    }

    public ExpressionNegative(String identity, Expression expression) {
        super(identity, ExpressionType.NUMBER, expression);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Expression v = getExpression().eval(environment);
        if(!v.getType().isNumber()) {
            throw new BadTypedException(this,
                "Parameter must be a number. Argument given:" + v);
        }
        return((ExpressionNumber) v).neg();
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionNegative(getName(),
            getExpression().rebuild(novo));
    }
}
