package jpel.language.operators;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.language.BadTypedException;
import jpel.language.Environment;
import jpel.language.ExecutionException;
import jpel.language.Expression;
import jpel.language.ExpressionBoolean;
import jpel.language.ExpressionType;
import jpel.language.MapReplace;
import jpel.language.UnaryExpression;

/**
 * Operao negao de booleanos.
 */
public class ExpressionNot extends UnaryExpression {

    public ExpressionNot(Expression expression) {
        this("not", expression);
    }

    public ExpressionNot(String identity, Expression expression) {
        super(identity, ExpressionType.BOOLEAN, expression);
    }

    public Expression eval(Environment environment) throws
        ExecutionException {
        Expression v = getExpression().eval(environment);
        if(!v.getType().isBoolean()) {
            throw new BadTypedException(this,
                "Parameter must be a boolean. Argument given:" + v);
        }
        return ExpressionBoolean.getBoolean(!((ExpressionBoolean) v).getBoolean());
    }

    public Expression rebuild(MapReplace map) {
        MapReplace novo = map.mirror();
        return new ExpressionNot(getName(), getExpression().rebuild(novo));
    }
}
