package jpel.remote.language.rmi;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.rmi.Remote;
import java.rmi.RemoteException;

import jpel.language.ExecutionException;
import jpel.language.Expression;

/**
 * Mascara o servidor para disponibilizao de servios remotos RMI.
 */
public interface ExpressionServerRMI extends Remote {

    /**
     * Executa uma expresso em um ambiente remoto.
     * @param expression Expresso que deve ser avaliada.
     * @return O resultado da expresso remota.
     * @throws ExecutionException Quando h falha na execuo da expresso.
     * @throws RemoteException Quando h problemas remotos.
     */
    Expression execute( Expression expression ) throws ExecutionException,
        RemoteException;
}
