package jpel.remote.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.resolver.Configuration;
import jpel.resolver.ConfigurationBuilder;
import jpel.resolver.ConfigurationException;
import jpel.resolver.DynamicConfiguration;
import jpel.resolver.StaticConfiguration;

public class ConfigurationBuilderRemote extends ConfigurationBuilder {

    public static StaticConfiguration staticConfiguration( StaticConfiguration
        conf ) throws ConfigurationException {
        return staticConfiguration( conf.getString( "REMOTE.SERVER" ),
            conf.getInt( "REMOTE.PORT" ) );
    }

    public static StaticConfiguration staticConfiguration( String host,
        int port ) throws ConfigurationException {
        return new StaticConfigurationClient( host, port );
    }

    public static DynamicConfiguration dynamicConfiguration(
        StaticConfiguration conf ) throws ConfigurationException {
        return dynamicConfiguration( conf.getString( "REMOTE.SERVER" ),
            conf.getInt( "REMOTE.PORT" ) );
    }

    public static DynamicConfiguration dynamicConfiguration( String host,
        int port ) throws ConfigurationException {
        return new DynamicConfigurationClient( host, port );
    }

    public static void export( int port,
        Configuration conf ) throws ConfigurationException {
        new ConfigurationServer( port, conf );
    }
}
