package jpel.remote.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.resolver.ConfigurationException;
import jpel.resolver.DynamicConfigurationImpl;

public class DynamicConfigurationClient extends DynamicConfigurationImpl {

    private ConfigurationClient helper;

    public DynamicConfigurationClient( String host,
        int port ) throws ConfigurationException {
        super();
        helper = new ConfigurationClient( host, port );
    }

    public void load( Object obj ) throws ConfigurationException {
        helper.load( obj );
        clear();
    }

    public void reload() throws ConfigurationException {
        helper.reload();
        rebind();
    }

    public Object process( Object command ) throws ConfigurationException {
        return helper.process( command );
    }
}
