package jpel.remote.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.resolver.ConfigurationBuilder;
import jpel.resolver.DynamicConfiguration;
import jpel.resolver.StaticConfiguration;
import jpel.util.Debugger;

public class RunConfigurationClient {

    public static void main( String[] args ) {
        try {
            Debugger.enableDebug();

            StaticConfiguration sc = ConfigurationBuilder.staticConfiguration(
                                     args );
            DynamicConfiguration dc = ConfigurationBuilderRemote.
                                      dynamicConfiguration(
                                      sc.getString( "HOST" ), sc.getInt( "PORT" )
                                      );
            Example e = new Example();
            dc.bind( e, "setPBoolean", boolean.class, "debug" );
            dc.bind( e, "setPInt", int.class,
                "if { time % 2 == 0 } then {0} else {1}" );
            dc.bind( e, "setPInta", int[].class, "[4,5,6]" );
            dc.reload();

            dc.load( new java.io.File( "examples/client.xml" ) );
            ConfigurationBuilderRemote.export( sc.getInt( "PORT + 1" ), sc );
        }
        catch( Exception exc ) {
            exc.printStackTrace();
        }
    }
}
