package jpel.remote.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.resolver.ConfigurationBuilder;
import jpel.resolver.DynamicConfiguration;
import jpel.resolver.Policy;
import jpel.resolver.PolicyActivateOnChange;
import jpel.resolver.PolicyActivateOnNotify;
import jpel.resolver.PolicyListener;
import jpel.resolver.PolicyListenerReload;
import jpel.util.Debugger;

public class RunConfigurationServer {

    public static void main( String[] args ) {
        try {
            Debugger.enableDebug();

            DynamicConfiguration conf = ConfigurationBuilder.
                                        dynamicConfiguration( args );
            Example e = new Example();
            conf.bind( e, "setPBoolean", boolean.class, "debug" );
            conf.bind( e, "setPInt", int.class, "remote.socket" );
            //conf.bind(e,"setPInta",int[].class,"[4,5,6]");
            conf.bind( e, "print" );
            conf.execute();
            ConfigurationBuilderRemote.export( 4001, conf );
            System.out.println( "Export done." );

            PolicyListener listener = new PolicyListenerReload();

            Policy change = new PolicyActivateOnChange();
            ( ( PolicyActivateOnChange ) change ).setPeriod( 30000 );
            change.addPolicyListener( listener );
            change.addConfiguration( conf );
            change.start();

            Policy notify = new PolicyActivateOnNotify();
            ( ( PolicyActivateOnNotify ) notify ).setPort( 3001 );
            notify.addPolicyListener( listener );
            notify.addConfiguration( conf );
            notify.start();
        }
        catch( Exception exc ) {
            exc.printStackTrace();
        }
    }
}
