package jpel.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Realiza a validao e execuo de metodos, tipos e comandos necessrios a
 * parametrizao dinmica que usa a linguagem funcional.
 */
public interface Binder {

    /**
     * Verifica a validade de um bind. Tipicamente verifica se no objeto
     * solicitado existe o mtodo indicado no bind, se os tipos dos mtodo
     * e do objeto fornecido so compatveis.
     * @param bind Bind que deve ser validado.
     * @throws BinderException Quando o bind no  vlido.
     */
    void validate(Bind bind) throws BinderException;

    /**
     * Executa um bind. Isto , no objeto indicado, chama o metodo com o tipo
     * dado passando o argumento.
     * @param bind Bind que deve ser executado.
     * @throws BinderException Quando h falha na tipagem das chamadas.
     */
    void execute(Bind bind) throws BinderException;
}