package jpel.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.Vector;

/**
 * Imlpementao base de uma Policy.
 */

public abstract class PolicyImpl implements Policy {

    transient private Vector policyListeners;

    public PolicyImpl() {}

    public synchronized void addPolicyListener(PolicyListener l) {
        Vector v = policyListeners == null ? new Vector(2)
                   : (Vector) policyListeners.clone();
        if(!v.contains(l)) {
            v.addElement(l);
            policyListeners = v;
        }
    }

    public synchronized void removePolicyListener(PolicyListener l) {
        if(policyListeners != null && policyListeners.contains(l)) {
            Vector v = (Vector) policyListeners.clone();
            v.removeElement(l);
            policyListeners = v;
        }
    }

    public void firePolicyActivated(PolicyEvent e) {
        if(policyListeners != null) {
            Vector listeners = policyListeners;
            int count = listeners.size();
            for(int i = 0; i < count; i++) {
                ((PolicyListener) listeners.elementAt(i)).policyActivated(
                    e);
            }
        }
    }
}