package jpel.resolver;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Define uma configurao esttica que pode ser usada pelo sistema. Neste contexto,
     * esttica significa que os parametros j chamados para ajustes dos objetos no
 * sero reavaliados e modificados nas classes que os utilizam. As mudanas de
 * valores sero vlidas apenas para novas solicitaes de parmetros.
 */
public interface StaticConfiguration extends Configuration {

// booleans
    boolean getBoolean(String command) throws ConfigurationException;

    Boolean getBooleanObject(String command) throws ConfigurationException;

    boolean getBoolean(String command, boolean defaultValue);

    Boolean getBooleanObject(String command, Boolean defaultValue);

    boolean[] getBooleanArray(String command) throws ConfigurationException;

    Boolean[] getBooleanObjectArray(String command) throws
        ConfigurationException;

    boolean[] getBooleanArray(String command, boolean[] defaultValue);

    Boolean[] getBooleanObjectArray(String command, Boolean[] defaultValue);

// chars
    char getChar(String command) throws ConfigurationException;

    Character getCharObject(String command) throws ConfigurationException;

    char getChar(String command, char defaultValue);

    Character getCharObject(String command, Character defaultValue);

    char[] getCharArray(String command) throws ConfigurationException;

    Character[] getCharObjectArray(String command) throws
        ConfigurationException;

    char[] getCharArray(String command, char[] defaultValue);

    Character[] getCharObjectArray(String command, Character[] defaultValue);

// bytes
    byte getByte(String command) throws ConfigurationException;

    Byte getByteObject(String command) throws ConfigurationException;

    byte getByte(String command, byte defaultValue);

    Byte getByteObject(String command, Byte defaultValue);

    byte[] getByteArray(String command) throws ConfigurationException;

    Byte[] getByteObjectArray(String command) throws ConfigurationException;

    byte[] getByteArray(String command, byte[] defaultValue);

    Byte[] getByteObjectArray(String command, Byte[] defaultValue);

// shorts
    short getShort(String command) throws ConfigurationException;

    Short getShortObject(String command) throws ConfigurationException;

    short getShort(String command, short defaultValue);

    Short getShortObject(String command, Short defaultValue);

    short[] getShortArray(String command) throws ConfigurationException;

    Short[] getShortObjectArray(String command) throws ConfigurationException;

    short[] getShortArray(String command, short[] defaultValue);

    Short[] getShortObjectArray(String command, Short[] defaultValue);

// integers
    int getInt(String command) throws ConfigurationException;

    Integer getIntObject(String command) throws ConfigurationException;

    int getInt(String command, int defaultValue);

    Integer getIntObject(String command, Integer defaultValue);

    int[] getIntArray(String command) throws ConfigurationException;

    Integer[] getIntObjectArray(String command) throws ConfigurationException;

    int[] getIntArray(String command, int[] defaultValue);

    Integer[] getIntObjectArray(String command, Integer[] defaultValue);

// longs
    long getLong(String command) throws ConfigurationException;

    Long getLongObject(String command) throws ConfigurationException;

    long getLong(String command, long defaultValue);

    Long getLongObject(String command, Long defaultValue);

    long[] getLongArray(String command) throws ConfigurationException;

    Long[] getLongObjectArray(String command) throws ConfigurationException;

    long[] getLongArray(String command, long[] defaultValue);

    Long[] getLongObjectArray(String command, Long[] defaultValue);

// floats
    float getFloat(String command) throws ConfigurationException;

    Float getFloatObject(String command) throws ConfigurationException;

    float getFloat(String command, float defaultValue);

    Float getFloatObject(String command, Float defaultValue);

    float[] getFloatArray(String command) throws ConfigurationException;

    Float[] getFloatObjectArray(String command) throws ConfigurationException;

    float[] getFloatArray(String command, float[] defaultValue);

    Float[] getFloatObjectArray(String command, Float[] defaultValue);

// doubles
    double getDouble(String command) throws ConfigurationException;

    Double getDoubleObject(String command) throws ConfigurationException;

    double getDouble(String command, double defaultValue);

    Double getDoubleObject(String command, Double defaultValue);

    double[] getDoubleArray(String command) throws ConfigurationException;

    Double[] getDoubleObjectArray(String command) throws
        ConfigurationException;

    double[] getDoubleArray(String command, double[] defaultValue);

    Double[] getDoubleObjectArray(String command, Double[] defaultValue);

// strings
    String getString(String command) throws ConfigurationException;

    String getString(String command, String defaultValue);

    String[] getStringArray(String command) throws ConfigurationException;

    String[] getStringArray(String command, String[] defaultValue);

// objects
    Object getObject(String command) throws ConfigurationException;

    Object getObject(String command, Object defaultValue);

    Object[] getObjectArray(String command) throws ConfigurationException;

    Object[] getObjectArray(String command, Object[] defaultValue);
}