package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.GenericTool;

/**
 * Define o processo de converso de um n em outro objeto.
 */
public interface NodeConversor extends GenericTool {

    /**
         * Recebe um determinado n tranformando-o em outro objeto Java, caso o objeto
     * resultado tambm seja um n,  mais prudente utilizar a interface
     * NodeProcessor.
     * @param node N que deve ser convertido.
     * @return O objeto Java que correponde ao n dado.
     * @throws NodeException Quando acontece algum erro no processo de
     * converso do n.
     */
    Object convert(Node node) throws NodeException;

}