package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Representa uma fbrica de ns.
 */

public interface NodeFactory {

    /**
     * Retorna um n sem pai, nem valor.
     * @return Um n vazio.
     * @throws NodeException Quando no foi possvel criar o n.
     */
    Node getNode() throws NodeException;

    /**
     * Retorna um n sem pai, apenas com o valor.
     * @param value Valor que ser o atributo do n.
     * @return Um n cujo valor agregado  o objeto dado.
     * @throws NodeException Quando no foi possvel criar o n.
     */
    Node getNode(Object value) throws NodeException;

    /**
     * Retorna um n com pai e valor ajustados.
     * @param value Valor que ser agregado ao n.
     * @param parent N pai.
     * @return O n ajustado.
     * @throws NodeException Quando no foi possvel criar o n.
     */
    Node getNode(Object value, Node parent) throws NodeException;

}