package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Define um mecanismo de filtragem sobre a estrutura de ns.
 */
public interface NodeMatcher extends NodeProcessor {

    /**
     * Ajusta o padro que ser usado para filtrar os ns.
         * @param pattern Padro para busca. String no forma de expresses regulares.
     * @throws NodeException Quando h erro no ajuste do padro.
     */
    void setPattern(String pattern) throws NodeException;

    /**
     * Retorna o padro p/a filtragem.
     * @return O padro da procura.
     */
    String getPattern();

}