package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.GenericTool;

/**
 * Define interfaces para um processamento que transforma determinado n em outro.
 */
public interface NodeProcessor extends GenericTool {

    /**
     * Realiza a transformao de um n em outro.
     * @param node N que ser transformado/convertido/copiado/etc.
     * @return Um n convertido/etc.
         * @throws NodeException Quando acontece algum problema durante a converso.
     */
    Node process(Node node) throws NodeException;
}