package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.GenericTool;
import jpel.util.dataholder.DataHolder;
import jpel.util.dataholder.DataHolderException;

/**
 * Define interfaces para leitura de ns.
 */
public interface NodeReader extends GenericTool {

    /**
     * L os dados de um n de uma fonte de dados.
     * @param holder Fonte de dados.
     * @return O n que corresponde a fonte de dados.
     * @throws NodeException Quando h problemas com o n lido.
     * @throws DataHolderException Quando h problemas na leitura dos dados.
     */
    Node read(DataHolder holder) throws NodeException, DataHolderException;
}
