package jpel.tree;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import jpel.util.GenericTool;
import jpel.util.dataholder.DataHolder;
import jpel.util.dataholder.DataHolderException;

/**
 * Define interfaces para escrita de ns.
 */
public interface NodeWriter extends GenericTool {

    /**
     * Escreve os dados de um n de uma fonte de dados.
     * @param node N que deve ser escrito.
     * @param holder Fonte de dados.
     * @throws NodeException Quando h problemas com o n lido.
     * @throws DataHolderException Quando h problemas na leitura dos dados.
     */
    void write(Node node, DataHolder holder) throws NodeException,
        DataHolderException;
}