package jpel.util;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

/**
 * Definio bsica de uma ferramenta de propsito geral.
 */
public interface GenericTool {

    /**
     * Retorna os tipos dos objetos que podem ser tratados por tal ferramenta.
     * @return Um array com todos os tipos suportados pela ferramenta.
     */
    String[] getTypes();

    /**
     * Retorna a descrio da ferramenta.
     * @return Uma descrio da ferramenta.
     */
    String getDescription();
}