package jpel.util.dataholder;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;

import jpel.util.Debugger;

/**
 * Implementao referencia p/quem quer fazer uma fonte de recursos.
 */
public abstract class AbstractDataHolder implements DataHolder {

    private int type;
    private Object reference;

    private InputStream bInputStream;
    private OutputStream bOutputStream;
    private Reader bReader;
    private Writer bWriter;

    public AbstractDataHolder() {}

    public AbstractDataHolder(int type) {
        setType(type);
    }

    public AbstractDataHolder(int type, Object reference) {
        setType(type);
        setReference(reference);
    }

    public void setType(int type) {
        this.type = type;
    }

    public int getType() {
        return type;
    }

    public void setReference(Object reference) {
        this.reference = reference;
    }

    public Object getReference() {
        return reference;
    }

    protected void setBInputStream(InputStream newBInputStream) {
        bInputStream = newBInputStream;
    }

    protected InputStream getBInputStream() {
        return bInputStream;
    }

    protected void setBOutputStream(OutputStream newBOutputStream) {
        bOutputStream = newBOutputStream;
    }

    protected OutputStream getBOutputStream() {
        return bOutputStream;
    }

    protected void setBReader(Reader newBReader) {
        bReader = newBReader;
    }

    protected Reader getBReader() {
        return bReader;
    }

    protected void setBWriter(Writer newBWriter) {
        bWriter = newBWriter;
    }

    protected Writer getBWriter() {
        return bWriter;
    }

    public void close() throws DataHolderException {
        if(getBInputStream() != null) {
            try {
                getBInputStream().close();
                setBInputStream(null);
            }
            catch(IOException exc) {
                throw new DataHolderException(exc.getMessage(), exc);
            }
        }
        if(getBOutputStream() != null) {
            try {
                getBOutputStream().close();
                setBOutputStream(null);
            }
            catch(IOException exc) {
                throw new DataHolderException(exc.getMessage(), exc);
            }
        }
        if(getBReader() != null) {
            try {
                getBReader().close();
                setBReader(null);
            }
            catch(IOException exc) {
                throw new DataHolderException(exc.getMessage(), exc);
            }
        }
        if(getBWriter() != null) {
            try {
                getBWriter().close();
                setBWriter(null);
            }
            catch(IOException exc) {
                throw new DataHolderException(exc.getMessage(), exc);
            }
        }
        Debugger.println("AIS", "close", toString());
    }
}