package jpel.util.dataholder;

/**
 * <p>Title: Configuration in Java</p>
 * <p>Description: Ferramentas e tcnicas para ajuste de sistemas feitos em Java.</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: CIN - UFPE</p>
 * @author Thiago Santos (tlvls@cin.ufpe.br)
 * @version 1.0
 */

import java.util.List;

import jpel.util.GenericTool;

/**
 * A partir de uma fonte de dados determina se existem outras fontes que podem ser
 * derivadas a partir dela.
 */
public interface DataHolderExtractor extends GenericTool {

    /**
     * Produces a list of data sources derived from the given source.
     * @param holder The source
     * @return A List of DataHolder objects.
         * @throws DataHolderException When there is a problem to find the DataHolders
     * derived from the given source.
     */
    List extract(DataHolder holder) throws DataHolderException;

}