package jpel.util.dataholder;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

/**
 * Define uma fbrica de fontes de recursos.
 */
public interface DataHolderFactory {

    /**
         * Cria um DataHolder a partir da referencia dada. Essa referencia, por exemplo,
     * proderia ser um arquivo ou mesmo uma URL.
     * @param reference O objeto Java que d origem  fonte de recursos.
     * @return Uma fonte de recursos completa.
     * @throws DataHolderFactoryException Quando no  possvel criar a fonte de recursos.
     */
    DataHolder produce(Object reference) throws DataHolderFactoryException;
}