package jpel.util.dataholder;

/**
 * Title:        Configuration in Java
 * Description:  Ferramentas e tcnicas para ajuste de sistemas feitos em Java.
 * Copyright:    Copyright (c) 2002
 * Company:      CIN - UFPE
 * @author
 * @version 1.0
 */

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.net.MalformedURLException;
import java.net.URL;

/**
 * Imlpementao padro da fbrica de fonte de recursos.
 */
public class DataHolderFactoryImpl implements DataHolderFactory {

    public DataHolderFactoryImpl() {}

    public DataHolder produce(Object reference) throws
        DataHolderFactoryException {
        DataHolder result = null;
        if(reference instanceof InputStream) {
            result = new DataHolderBinaryStream((InputStream) reference);
        }
        else if(reference instanceof OutputStream) {
            result = new DataHolderBinaryStream((OutputStream) reference);
        }
        else if(reference instanceof Reader) {
            result = new DataHolderCharacterStream((Reader) reference);
        }
        else if(reference instanceof Writer) {
            result = new DataHolderCharacterStream((Writer) reference);
        }
        else if(reference instanceof URL) {
            result = new DataHolderURL((URL) reference);
        }
        else if(reference instanceof File) {
            result = new DataHolderFile((File) reference);
        }
        else if(reference instanceof String || reference instanceof String[]) {
            String str = null;
            if(reference instanceof String) {
                str = (String) reference;
            }
            else {
                str = ((String[]) reference)[0];
            }
            if(str.indexOf("http:") >= 0) {
                try {
                    result = new DataHolderURL(str);
                }
                catch(MalformedURLException exc) {
                    throw new DataHolderFactoryException(
                        "Could not create a URL source to " + str);
                }
            }
            else {
                result = new DataHolderFile(str);
            }
        }
        return result;
    }
}
